var d = Object.defineProperty;
var c = (r, e, t) => e in r ? d(r, e, { enumerable: !0, configurable: !0, writable: !0, value: t }) : r[e] = t;
var n = (r, e, t) => c(r, typeof e != "symbol" ? e + "" : e, t);
var a = /* @__PURE__ */ ((r) => (r.COMPLETE = "complete", r.RESIZE = "resize", r.RESULT = "result", r.READY = "ready", r.INVALID = "invalid", r.MODAL = "openModal", r.ERROR = "error", r.CLOSE = "closeModal", r.CANCEL = "cancel", r))(a || {}), l = /* @__PURE__ */ ((r) => (r.UPDATE = "update", r.REQUEST_RESPONSE = "requestResponse", r))(l || {});
class m {
  constructor() {
    n(this, "listeners", /* @__PURE__ */ new Map());
    n(this, "port");
    this.handleMessage = this.handleMessage.bind(this);
  }
  setPort(e) {
    this.port = e, this.port.onmessage = this.handleMessage, this.port.start();
  }
  on(e, t) {
    this.listeners.has(e) || this.listeners.set(e, /* @__PURE__ */ new Set()), this.listeners.get(e).add(t);
  }
  off(e, t) {
    const s = this.listeners.get(e);
    s && (s.delete(t), s.size === 0 && this.listeners.delete(e));
  }
  handleMessage(e) {
    console.log("received message", e.data);
    const t = e.data;
    if (typeof t == "object" && t !== null && "type" in t) {
      const s = t.type, o = this.listeners.get(s);
      o && o.forEach((i) => i(t));
    }
  }
  // Method to send messages through the port
  send(e) {
    this.port && this.port.postMessage(e);
  }
}
class u {
  /**
   * Creates an instance of EmbeddedComponent.
   * @param url - The URL of the embedded component
   * @param value - The initial transaction value
   */
  constructor(e, t) {
    n(this, "_url");
    n(this, "_value");
    n(this, "_errors", []);
    n(this, "iframe");
    n(this, "eventManager");
    n(this, "modal");
    this._url = e, this._value = t, this.eventManager = new m(), this.on(a.INVALID, (s) => {
      s.type === a.INVALID && (this._errors = s.errors, this._value = s.value);
    }), this.on(a.RESIZE, (s) => {
      s.type === a.RESIZE && this.iframe && (this.iframe.style.height = `${s.height}px`);
    });
  }
  /**
   * Gets the URL of the embedded component
   * @returns The URL of the embedded component
   */
  get url() {
    return this._url;
  }
  /**
   * Gets the current transaction value
   * @returns The current transaction value
   */
  get value() {
    return this._value;
  }
  get errors() {
    return this._errors;
  }
  /**
   * Opens the component URL in the current window
   */
  open() {
    document.location.href = this.url;
  }
  /**
   * Mounts the component to a parent element
   * @param parentId - The ID of the parent element
   * @throws Will throw an error if the parent element is not found
   */
  mount(e) {
    const t = document.querySelector(e);
    if (!t) throw new Error(`parentID ${e} not found`);
    this.embed(t);
  }
  /**
   * Embeds the component into a parent element
   * @param parent - The parent element to embed the component into
   */
  embed(e) {
    var t, s;
    this.iframe = document.createElement("iframe"), this.iframe.src = this.url, this.iframe.style.width = "100%", this.iframe.style.height = "100px", this.iframe.style.border = "none", this.iframe.style.overflow = "hidden", this.iframe.setAttribute("allowtransparency", "true"), this.iframe.style.backgroundColor = "transparent", e.appendChild(this.iframe), window.addEventListener("message", (o) => {
      var i, h;
      o.source === ((i = this.iframe) == null ? void 0 : i.contentWindow) && (console.log("received message from iframe", o.data), (h = this.eventManager) == null || h.setPort(o.ports[0]));
    }), (s = (t = this.iframe) == null ? void 0 : t.contentWindow) == null || s.focus();
  }
  /**
   * Sends a message to the embedded component
   * @param message - The message to send
   */
  send(e) {
    this.eventManager.send(e);
  }
  /**
   * Adds an event listener for a specific message type
   * @param messageType - The type of message to listen for
   * @param callback - The callback function to execute when the message is received
   */
  on(e, t) {
    this.eventManager.on(e, t);
  }
  /**
   * Removes an event listener for a specific message type
   * @param messageType - The type of message to stop listening for
   * @param callback - The callback function to remove
   */
  off(e, t) {
    this.eventManager.off(e, t);
  }
  /**
   * Updates the transaction value and sends an update message to the component
   * @param value - The new transaction value
   */
  update(e) {
    this._value = e, this.send({ type: l.UPDATE, value: e });
  }
  /**
   * Waits for the component to complete and returns the transaction response
   * @returns A promise that resolves with the transaction response
   */
  completion() {
    return new Promise((e, t) => {
      this.on(a.COMPLETE, (s) => {
        e(s.response);
      }), this.on("error", (s) => {
        t(new Error(s.message));
      });
    });
  }
  /**
   * Opens the component in a modal dialog
   */
  openModal() {
    return this.modal && this.closeModal(), this.modal = document.createElement("dialog"), this.modal.style.border = "none", this.modal.style.backgroundColor = "transparent", this.modal.style.maxWidth = "100vw", this.modal.style.maxHeight = "100vh", this.modal.style.width = "600px", this.modal.style.height = "800px", document.body.appendChild(this.modal), this.embed(this.modal), this.on(a.CANCEL, () => {
      this.closeModal();
    }), this.on(a.CLOSE, () => {
      this.closeModal();
    }), this.on(a.COMPLETE, () => {
      this.closeModal();
    }), this.modal.showModal(), this.modal.addEventListener("click", () => {
      this.closeModal();
    }), this.completion();
  }
  /**
   * Closes the modal dialog
   *
   */
  closeModal() {
    var e;
    this.modal && (console.log("closeModal"), (e = this.modal) == null || e.close(), this.modal.remove(), this.modal = void 0);
  }
}
function f(r) {
  return Object.entries(r).map(([e, t]) => {
    if (!(e && t)) return;
    const s = encodeURIComponent(e), o = encodeURIComponent(
      typeof t == "object" ? JSON.stringify(t) : t
    );
    return `${s}=${o}`;
  }).filter((e) => !!e).join("&");
}
class E {
  /**
   * Creates a new instance of the Notabene SDK
   *
   * @param config - Configuration options for the Notabene SDK
   */
  constructor(e) {
    n(this, "nodeUrl");
    n(this, "authToken");
    n(this, "uxUrl");
    n(this, "theme");
    n(this, "locale");
    this.uxUrl = e.uxUrl || "https://connect.notabene.id", this.nodeUrl = e.nodeUrl, this.authToken = e.authToken, this.theme = e.theme, this.locale = e.locale;
  }
  /**
   * Generates a URL for a Notabene component
   *
   * @param path - The path of the component
   * @param value - Transaction data
   * @param configuration - Optional transaction configuration
   * @param callbacks - Optional callback configuration
   * @returns component URL
   * @internal
   */
  componentUrl(e, t, s, o) {
    const i = new URL(this.uxUrl);
    i.pathname = e;
    const h = f({
      authToken: this.authToken,
      value: t,
      configuration: s
    });
    return i.hash = h, this.nodeUrl && i.searchParams.set("nodeUrl", this.nodeUrl), this.theme && i.searchParams.set("theme", JSON.stringify(this.theme)), this.locale && i.searchParams.set("locale", this.locale), o && (o.callback && i.searchParams.set("callback_url", o.callback), o.redirectUri && i.searchParams.set("redirect_uri", o.redirectUri)), i.toString();
  }
  /**
   * Creates a new embedded component
   *
   * @param path - The path of the component
   * @param value - Transaction data
   * @param options - Optional transaction options
   * @param callbacks - Optional callback configuration
   * @returns A new EmbeddedComponent instance
   * @internal
   */
  createComponent(e, t, s, o) {
    return new u(
      this.componentUrl(e, t, s, o),
      t
    );
  }
  /**
   * Creates a withdrawal assist component
   *
   * @param value - Withdrawal transaction data
   * @param options - Optional transaction options
   * @param callbacks - Optional callback configuration
   * @returns A new EmbeddedComponent instance for withdrawal assistance
   */
  createWithdrawalAssist(e, t, s) {
    return this.createComponent("withdrawal-assist", e, t, s);
  }
  /**
   * Creates a deposit assist component
   *
   * @param value - Deposit transaction data
   * @param options - Optional transaction options
   * @param callbacks - Optional callback configuration
   * @returns A new EmbeddedComponent instance for deposit assistance
   * @alpha
   */
  createDepositAssist(e, t, s) {
    return this.createComponent(
      "deposit-assist",
      e,
      t,
      s
    );
  }
  /**
   * Creates a connect component
   *
   * @param value - Connection request data
   * @param options - Optional transaction options
   * @param callbacks - Optional callback configuration
   * @returns A new EmbeddedComponent instance for connection
   */
  createConnectWallet(e, t, s) {
    return this.createComponent(
      "connect",
      e,
      t,
      s
    );
  }
  /**
   * Creates a deposit request component
   *
   * @param value - Deposit request data
   * @param options - Optional transaction options
   * @param callbacks - Optional callback configuration
   * @returns A new EmbeddedComponent instance for deposit requests
   * @alpha
   */
  createDepositRequest(e, t, s) {
    return this.createComponent("deposit-request", e, t, s);
  }
  /**
   * Decodes a URL fragment into an object
   *
   * @param fragment - The URL fragment to decode
   * @returns An object containing the decoded key-value pairs
   */
  decodeFragmentToObject(e) {
    return e.slice(1).split("&").reduce(
      (s, o) => {
        const [i, h] = o.split("=");
        return s[decodeURIComponent(i)] = decodeURIComponent(h), s;
      },
      {}
    );
  }
}
export {
  E as default
};
